var LevelNr = 1;	//Variable, die die Nummer des aktuellen Levels enthlt

var BallGeschwindigkeit = 30;

function BallEvent()
{
	vec_set(my.skill20,bounce);
	my.skill23 = sqrt(my.skill20*my.skill20+my.skill21*my.skill21+my.skill22*my.skill22);
	my.skill20 = my.skill20/abs(my.skill23);
	my.skill21 = my.skill21/abs(my.skill23);
	my.skill22 = my.skill22/abs(my.skill23);
	
	vec_scale(my.skill20,BallGeschwindigkeit);
}

action Ball
{
	my.polygon = on;
	my.narrow = off;
	my.fat = off;
	while(!key_space){wait(1);}
	my.enable_entity = on;
	my.enable_block = on;
	my.event = BallEvent;
	
	if(my.x > player.x)
	{
		my.skill20 = BallGeschwindigkeit;
	}else
	{
		if(my.x < player.x)
		{
			my.skill20 = -BallGeschwindigkeit;
		}
	}
	
	if(my.y > player.y)
	{
		my.skill21 = BallGeschwindigkeit;
	}else
	{
		if(my.y < player.y)
		{
			my.skill21 = -BallGeschwindigkeit;
		}
	}
	
	if(my.z > player.z)
	{
		my.skill22 = BallGeschwindigkeit;
	}else
	{
		if(my.z < player.z)
		{
			my.skill22 = -BallGeschwindigkeit;
		}
	}
	
	while(player && me)
	{
		c_move(me,nullvector,vector(my.skill20*time_step,my.skill21*time_step,my.skill22*time_step),0);
		wait(1);
	}
	ent_remove(me);
}

string Ball_mdl = <Ball.mdl>;
var BallAbstand = 50;
var BallGrosse = 0.2;

function erstelleBall()
{
	var BallPos[3];
	
	BallPos.x = my.x+BallAbstand*cos(my.pan+90)*cos(my.roll+90);
	BallPos.y = my.y+BallAbstand*sin(my.pan+90)*cos(my.roll+90);
	BallPos.z = my.z+BallAbstand*sin(my.roll+90);
	
	you = ent_create(Ball_mdl,BallPos,Ball);
	
	you.scale_x = BallGrosse;
	you.scale_y = BallGrosse;
	you.scale_z = BallGrosse;
}

function ZahleZeit()
{
	while(me && my.skill5 > 0)
	{
		my.skill5 -= 1;
		sleep(1);
	}
	LevelNr += 1;
	wait(1);
	ent_remove(me);
}

var CamAbstand = 1000;	//Der Wert dieser Variablen gibt den Abstand der Kamera zum Mittelpunkt an
var CamPan_Winkel = 90;
var CamTilt_Winkel;
var CamDreh_Geschwindigkeit = 1;	//Der Wert dieser Variablen gibt die Geschwindgkeit der Kamerabewegung an
var CamGenauigkeit = 0.5;

function drehe_Kamera()
{
	vec_scale(my.skill2,CamAbstand);	//Multiplitziere den Vektor my.skill2(-3) mit CamAbstand
	
	while(my.flag1 == off)	//Solange my.flag1 aus ist
	{
		camera.x = 0-CamAbstand*cos(CamPan_Winkel)*cos(CamTilt_Winkel);	//Bekomme mit Hilfe von Sinus und Cosinus die Position
		camera.y = 0-CamAbstand*sin(CamPan_Winkel)*cos(CamTilt_Winkel);	//der Kamera auf der Linie eines Kreises um den Mittelpukt
		camera.z = 0-CamAbstand*sin(CamTilt_Winkel);								//mit einem Radius von CamAbstand
		
		// hole die Richtung von der Kamera zum Mittelpunkt
		vec_set(temp,nullvector);	
		vec_sub(temp,camera.x);
		vec_to_angle(camera.pan,temp); // und drehe dir Kamera, so dass sie jetzt den Mittelpunkt anschaut
	
		if(my.skill2)
		{	
			if(camera.x < my.skill2)	//Wenn die X-Koordinate der Kamera kleiner ist als die X-Zielkoordinate
			{
				CamPan_Winkel += CamDreh_Geschwindigkeit*time_step;	//dann nhere die Kamera dieser Position durch addition an
			}else	//sonst
			{
				CamPan_Winkel -= CamDreh_Geschwindigkeit*time_step;	//nhere die Kamera dieser Position durch subtraktion an.
			}
		}
		
		if(my.skill3)
		{
			if(camera.y < my.skill3-CamGenauigkeit)	//Wenn die Y-Koordinate der Kamera kleiner ist als die Y-Zielkoordinate
			{
				CamPan_Winkel += CamDreh_Geschwindigkeit*time_step;	//dann nhere die Kamera dieser Position durch addition an
			}else	//sonst
			{
				CamPan_Winkel -= CamDreh_Geschwindigkeit*time_step;	//nhere die Kamera dieser Position durch subtraktion an.
			}
		}
		
		if(camera.z < my.skill4-CamGenauigkeit)	//Wenn die Z-Koordinate der Kamera kleiner ist als die Z-Zielkoordinate
		{
			CamTilt_Winkel -= CamDreh_Geschwindigkeit*time_step;	//dann nhere die Kamera dieser Position durch addition an
		}else	//sonst
		{
			CamTilt_Winkel += CamDreh_Geschwindigkeit*time_step;	//nhere die Kamera dieser Position durch subtraktion an.
		}

		if((abs(camera.x) >= (CamAbstand-CamDreh_Geschwindigkeit*2) || abs(camera.y) >= (CamAbstand-CamDreh_Geschwindigkeit*2) || abs(camera.z) >= (CamAbstand-CamDreh_Geschwindigkeit*2)) && vec_dist(my.skill2,camera.x) <= CamDreh_Geschwindigkeit*30)	//Wenn X, Y oder Z der Kameraposition ungefhr so gro wie CamAbstand ist (senkrecht zu einer Seite steht) und der Abstand zum Vektor my.skill2(-4) kleiner ist als CamDreh_Geschwindigkeit
		{
			my.flag1 = on;	//setze my.flag1 auf on.
		}
		
		wait(1);
	}
}

var SchlagerGeschwindigkeit = 30;

action Schlager
{
	my.polygon = on;
	while(LevelNr < my.skill1){wait(10);}	//Warte bis das Level des Schlgers erreicht wurde
	drehe_Kamera();
	player = me;
	while(my.flag1 == off){wait(1);}
	erstelleBall();
	wait(1);
	ZahleZeit();
	
	while(me)
	{
		c_move(me,vector((key_a-key_d)*-SchlagerGeschwindigkeit*time_step,0,0),nullvector,0);
		wait(1);
	}
}